#include <ruby.h>
#include <node.h>
#include "yarvcore.h"

#ifndef _YARV_H_INCLUDED_
#define _YARV_H_INCLUDED_


VALUE yarv_yield _((VALUE val));

/* original API */

#if YARVEXT
RUBY_EXTERN int yarvIsWorking;
#define IS_YARV_WORKING() (yarvIsWorking)
#define SET_YARV_START()  (yarvIsWorking = 1)
#define SET_YARV_STOP()   (yarvIsWorking = 0)
#else
#define IS_YARV_WORKING() 1
#define SET_YARV_START()
#define SET_YARV_STOP() 
#endif

VALUE yarv_get_current_running_vm_value _(());
VALUE yarv_get_current_running_thread_value _(());

yarv_vm_t *yarv_get_current_running_vm _(());
yarv_thread_t *yarv_get_current_running_thread _(());

#define GET_THREAD() yarv_get_current_running_thread()

struct yarv_yield_data{
  yarv_thread_t *th;
  yarv_block_t *block;
  VALUE *pc;
  VALUE *sp;
  int argc;
  int local_size;
};

VALUE thread_yield_light_prepare _((VALUE self, int argc, VALUE *argv,
                                    struct yarv_yield_data *data));

VALUE th_invoke_yield(yarv_thread_t *th, int argc, VALUE *argv);

VALUE th_call0(yarv_thread_t *th, VALUE klass, VALUE recv,
               VALUE id, ID oid, int argc, const VALUE *argv,
               NODE *body, int nosuper);

VALUE *yarv_svar(int);

VALUE th_call_super(yarv_thread_t *th, int argc, const VALUE *argv);

VALUE yarv_backtrace(int lev);

VALUE yarvcore_eval_parsed(VALUE node, VALUE file);

#endif
